// (c) Display3000, Peter Ksters
// Autor: Peter Schindler
// es ist gestattet, diese Routinen in eigene Programme einzubauen,
// wenn die folgenden 4 Zeilen im Kopf Ihrer Software stehen. Ich
// denke, das ist eine faire Lsung.

// ------------------------------------------------------------------------------------------------------------
// Software-Grundlagen wurden von Peter Ksters, www.display3000.com ermittelt
// Weitere Displays, Platinen, Spezialstecker und fertige Module: www.display3000.com
// ------------------------------------------------------------------------------------------------------------
//
//
//
// Dieses Beispiel hier luft auf dem Board D062x von Display 3000, welches einen Atmega128 beinhaltet


#include "keyboard.h"

//init keyboard for module D062x
void keyboard_init(void)  {
  DDRD &= 0x0c;			//set all but pins 2 and 3 to input
  PORTD |= 0xf3;		//set pins 0,1,4,5,6,7 to 1 for intern pull up 
}

//asks for a keypress, returns 0 or pressed key
int keyhit(void)  {
  register unsigned char value = (~(PIND))&0xf3;
  switch(value)  {
    case 0x00:			return 0;
						break;
    case 0x01:			return KEY_ESC;
						break;
    case 0x02:			return KEY_CR;
						break;
    case 0x10:			return KEY_UP;
						break;
    case 0x20:			return KEY_LEFT;
						break;
    case 0x40:			return KEY_RIGHT;
						break;
    case 0x80:			return KEY_DOWN;
						break;
    default:			return 0;
  }
  return 0;
}


//waits until key is pressed
int getkey(void)  {
  int v;
  while(keyhit()!=0);				//wait for release of key
  while((v = keyhit())==0);		//wait for a new pressed key
  _delay_ms(40.0);
  return v;  
}
