#ifndef	__UART__H
#define __UART__H

#include <avr/io.h>
#include <util/delay.h>


#define SIORECBUFSIZE		150
#define SIOSENDBUFSIZE		150


typedef struct  {
  unsigned char Bytes        : 8;
  unsigned char NewRecByte   : 1;
  unsigned char Sending      : 1;
} SioBufStatusStruct;


extern unsigned char   Sio1RecBuf [SIORECBUFSIZE];
extern unsigned char   Sio1SendBuf[SIOSENDBUFSIZE];
extern short   Sio1RecBufPtr;
extern short   Sio1SendBufPtr;
extern short   Sio1SendBufEndPtr;
extern SioBufStatusStruct volatile Sio1BufStatus;


/*
 * Perform UART startup initialization.
 */
void	uart_init(unsigned long baudrate);

/*
 * Send one character to the UART.
 */
int	uart_putchar(int c);
int uart_putc(unsigned char c);
void uart_puts(char *s);

/*
 * Receive one character from the UART.
 */
int	uart_getchar(void);

/*
* check, if char is available from uart, return 0 if not, else 1
*/
int	uart_keyhit(void);

unsigned char Sio1GetRecByte(unsigned char *Data);
unsigned char Sio1FlushBuffers(void);

#endif
